% script file illustrate_Krylov2D.m
% 2D illustrations

A = [2 1; 1 3];

x0 = 1*[1; 1];
b = [1; 0];

x_ex = A\b;


maxit = 5;

% visualise the Krylov space
e1 = b-A*x0;
e2 = A*e1;

e1 = e1/norm(e1);
e2 = e2/norm(e2);

figure(1);
clf
hold on
Q=line([x0(1); e1(1)+x0(1)],[x0(2); e1(2)+x0(2)]);
set(Q,'color','r','linewidth',2)
Q=line([x0(1); e2(1)+x0(1)],[x0(2); e2(2)+x0(2)]);
set(Q,'color','b','linewidth',2)
axis equal

plot(x_ex(1),x_ex(2),'ro','markersize',12);


plot(x0(1),x0(2),'go','markersize',12)

x=x0;
r0=b-A*x0; % initial residual
p = r0;

normR = zeros(maxit,1);

for i=1:2
  z = A*p;
  nu = (r0'*r0)/(p'*z);
  
  x = x + nu*p;
  plot(x(1),x(2),'g*')
  
  
  r = r0 - nu*z;
  
  r2 = r'*r;
  
  mu = r2/(r0'*r0);
  
  % reinitialise
  p = r + mu*p;
  r0=r;
    
end
  
